// ftpops.cpp: implementation of the ftpops class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ip2ftp.h"
#include "ftpops.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

ftpops::ftpops()
{
	dirnameLength  = 1023;
	connectionMade = false;
}

ftpops::~ftpops()
{
	InternetCloseHandle(hSession);
	if (connectionMade) {InternetCloseHandle(hConnection);}
}

bool ftpops::openSession()
{
	hSession = InternetOpen("ip2ftp", PRE_CONFIG_INTERNET_ACCESS, NULL, NULL, 0);
	if (!hSession) {return false;}
	return true;
}

bool ftpops::openConnection(char *server, int port, char *username, char *password)
{
	hConnection = InternetConnect(hSession, server, port, username, password, INTERNET_SERVICE_FTP, 0, 0);
	if (!hConnection) {return false;}
	connectionMade = true;
	return true;
}

char* ftpops::getDirectory()
{
	FtpGetCurrentDirectory(hConnection, dirnameBuffer, &dirnameLength);
	return dirnameBuffer;
}

bool ftpops::movetoDirectory(char *fullpath)
{
	if(FtpSetCurrentDirectory(hConnection, fullpath)) {return true;}
	return false;
}

bool ftpops::uploadFile(char *localFilename, char *remoteFilename)
{

	if (FtpPutFile(hConnection, localFilename, remoteFilename, FTP_TRANSFER_TYPE_BINARY, 0)) {return true;}
	return false;

}
