// ip2ftp.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "ip2ftp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// The one and only application object

CWinApp theApp;

using namespace std;

void  printappinfo(bool *printoptions);
char* dropParam(char* param, int plen);
bool  allTrue(bool bset[], int num);

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;

	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		cerr << _T("Fatal Error: MFC initialization failed") << endl;
		nRetCode = 1;
	}
	else
	{
		// TODO: code your application's behavior here.

		// instances of the ftp and local function classes

		ftpops		ftpconn;
		ipops		findIP;

		// for file i/o

		ifstream	fin;
		ofstream	fout;

		// storage for ftp and local info

		char		*ftp;
		char		*port;			// (we will convert this into an int later)
		char		*username;
		char		*password;
		char		*directory;
		char		*filename;
		char		*addressnumber;	// (we will convert this into an int later)

		bool		set[7] = {false, false, false, false, false, false, false};

		// storage for printout options

		bool		printoutoptions[3] = {false, true, false};

		// whether we want to request missing information during execution

		bool		request;
		request = true;

		// no arguments passed in with application
		if (argc == 1)
		{
			printappinfo(printoutoptions);
			return nRetCode;
		}

		// iterate through all paramters passed in with application name
		for (int i = 1; i < argc; i++)
		{
			/*			
			if (argv[i][0] != '-')
			{
				// handle file reference here
				
				fin.open(argv[i], ios::in);
				if (fin == 0)
				{
					cout << endl;
					cout << "Could not read " << argv[i] << " as a config file!" << endl;
					return nRetCode;
				}
				
				// TODO: read config file into vars
				fin.close();
			}
			*/
			
			if (argv[i][0] == '-')
			{
				// handle parameters here

				if (strcmp(argv[1], "-author") == 0)
				{
					printoutoptions[0] = true;
					printoutoptions[1] = false;
					printappinfo(printoutoptions);
					return nRetCode;
				}

				if (strcmp(argv[1], "-extended") == 0)
				{
					printoutoptions[2] = true;
					printappinfo(printoutoptions);
					return nRetCode;
				}

				if (strcmp(argv[1], "-list") == 0)
				{

					printoutoptions[1] = false;
					printappinfo(printoutoptions);

					cout << endl;
					cout << "Initialising Winsock...";
					if (findIP.initWinsock()) {cout << "done!" << endl;}
					else
					{
						cout << "failed!" << endl;
						return nRetCode;
					}
					
					char* host;
					cout << "Finding Host Name...";
					if (host = findIP.getHostName())
					{
						cout << "done! (" << host << ")" << endl;
					}
					else 
					{
						cout << "failed!" << endl;
						return nRetCode;
					}

					int number;
					cout << "Determining number of addresses for host...";
					number = findIP.getnumAddresses();
					if (number != -1)
					{
						cout << "done! (" << number << ")" << endl;
					}
					else 
					{
						cout << "failed!" << endl;
						return nRetCode;
					}

					int k;
					char* anIP;
					cout << "Listing all known addresses..." << endl;
					for (k = 0; k < number; k++)
					{
						anIP = findIP.getIPAddress_byAddressNum(k);
						cout << "Address " << k << ": ";
						if (anIP != "e")
						{
							cout << anIP << endl;
						}
						else
						{
							cout << "failed!" << endl;
							return nRetCode;
						}
					}

					return nRetCode;
				}

				if (strcmp(argv[1], "-silent") == 0)
				{
					request = false;
				}

				if (strncmp(argv[i],"-ftp:", 5) == 0) 
				{
					if (strlen(argv[i]) > 5)
					{
						ftp = dropParam(argv[i], 5);
						set[0] = true;
					}
				}

				if (strncmp(argv[i],"-port:", 6) == 0) 
				{
					if (strlen(argv[i]) > 6)
					{
						port = dropParam(argv[i], 6);
						set[1] = true;
					}
				}

				if (strncmp(argv[i],"-username:", 10) == 0) 
				{
					if (strlen(argv[i]) > 10)
					{
						username = dropParam(argv[i], 10);
						set[2] = true;
					}
				}

				if (strncmp(argv[i],"-password:", 10) == 0) 
				{
					if (strlen(argv[i]) > 10)
					{
						password = dropParam(argv[i], 10);
						set[3] = true;
					}
				}

				if (strncmp(argv[i],"-directory:", 11) == 0) 
				{
					if (strlen(argv[i]) > 11)
					{
						directory = dropParam(argv[i], 11);
						set[4] = true;
					}
				}

				if (strncmp(argv[i],"-filename:", 10) == 0) 
				{
					if (strlen(argv[i]) > 10)
					{
						filename = dropParam(argv[i], 10);
						set[5] = true;
					}
				}

				if (strncmp(argv[i],"-addressnumber:", 15) == 0) 
				{
					if (strlen(argv[i]) > 15)
					{
						addressnumber = dropParam(argv[i], 15);
						set[6] = true;
					}
				}

			}

		}

		if (!allTrue(set, 7))
		{
			// NOT all the required information has been set yet
			cout << endl;
			cout << "Some of the information required could not be read from" << endl;
			cout << "a config file and was not provided within the paramaters" << endl;
			cout << "executing this application!" << endl;

			if (request)
			{
				if (!set[0])
				{
					cout << "FTP Location? ";
					ftp = new char[MAX_PATH];
					cin  >> ftp;
					cout << endl;
				}
				if (!set[1])
				{
					cout << "Port #? ";
					port = new char[MAX_PATH];
					cin  >> port;
					cout << endl;
				}
				if (!set[2])
				{
					cout << "Username? ";
					username = new char[MAX_PATH];
					cin  >> username;
					cout << endl;
				}
				if (!set[3])
				{
					cout << "Password? ";
					password = new char[MAX_PATH];
					cin  >> password;
					cout << endl;
				}
				if (!set[4])
				{
					cout << "Remote Directory? ";
					directory = new char[MAX_PATH];
					cin  >> directory;
					cout << endl;
				}
				if (!set[5])
				{
					cout << "Remote Filename? ";
					filename = new char[MAX_PATH];
					cin  >> filename;
					cout << endl;
				}
				if (!set[6])
				{
					cout << "Local Host Address Number? ";
					addressnumber = new char[MAX_PATH];
					cin  >> addressnumber;
					cout << endl;
				}
			}
			else
			{
				cout << endl;
				cout << "Silent Mode : Information will not be requested." << endl;
				return nRetCode;
			}
		}

		// perform...

		cout << endl;
		cout << "Initialising Winsock...";
		if (findIP.initWinsock()) {cout << "done!" << endl;}
		else
		{
			cout << "failed!" << endl;
			return nRetCode;
		}
		
		char* host;
		cout << "Finding Host Name...";
		if (host = findIP.getHostName())
		{
			cout << "done! (" << host << ")" << endl;
		}
		else 
		{
			cout << "failed!" << endl;
			return nRetCode;
		}

		int num;
		cout << "Determining Number of Host Addresses...";
		num = findIP.getnumAddresses();

		if (num != -1)
		{
			cout << "done! (" << num << ")" << endl;
		}
		else 
		{
			cout << "failed!" << endl;
			return nRetCode;
		}

		char *ipAddress;
		cout << "Determining IP Address " << addressnumber << "...";
		ipAddress = findIP.getIPAddress_byAddressNum(atoi(addressnumber));
		if (ipAddress != "e")
		{
			cout << "done! (" << ipAddress << ")" << endl;
		}
		else
		{
			cout << "failed!" << endl;
			return nRetCode;
		}

		cout << "Writing a Temporary IP Address File...";
		fout.open("ip2ftp.tmp", ios::out);
		if (fout != 0)
		{
			fout << ipAddress;
			fout.close();
			cout << "done! (ip2ftp.tmp)" << endl;
		}
		else
		{
			cout << "failed!" << endl;
			return nRetCode;
		}

		cout << "Initialising Online Session...";
		if (ftpconn.openSession())
		{
			cout << "done!" << endl;
		}
		else
		{
			cout << "failed!" << endl;
			return nRetCode;
		}

		cout << "Establishing connection to " << ftp << "...";
		if (ftpconn.openConnection(ftp, atoi(port), username, password))
		{
			cout << "done!" << endl;
		}
		else
		{
			cout << "failed!" << endl;
			return nRetCode;
		}

		cout << "Moving to directory " << directory << "...";
		if (ftpconn.movetoDirectory(directory))
		{
			cout << "done!" << endl;
		}
		else
		{
			cout << "failed!" << endl;
			return nRetCode;
		}


		cout << "Uploading IP Address into file " << filename << "...";
		if(ftpconn.uploadFile("ip2ftp.tmp", filename))
		{
			cout << "done!" << endl;
			cout << endl;
			cout << "Process was successful!" << endl;
		}
		else
		{
			cout << "failed!" << endl;
			return nRetCode;
		}


	}

	return nRetCode;
}

void printappinfo(bool *printoptions)
{

	cout << "Ip2Ftp Version (Alpha)" << endl;

	if (printoptions[0])
	{
		cout << endl;
		cout << "Written by Dominic FA Manley." << endl;
		cout << "Please visit http://www.m1ckey.uklinux.net" << endl;
		cout << "Email any comments/suggestions/bugs to ip2ftp@m1ckey.uklinux.net" << endl;		
	}

	if (printoptions[1])
	{
		cout << endl;
		cout << "[Usage]" << endl;
		cout << "  ip2ftp [options]" << endl;
		//cout << endl;
		//cout << "    [config]" << endl;
		//cout << "      Full path to a config file specifying local/remote information." << endl;
		cout << endl;
		cout << "    [options]" << endl;
		cout << "      -author   : Displays application author information." << endl;
		cout << "      -extended : Displays the extended list of options." << endl;
		cout << "      -list     : Lists the host addresses and corresponding numbers." << endl;
		cout << "                  NOTE: Useful for identifying your required *online*" << endl;
		cout << "                        address." << endl;
		cout << "      -silent   : Will not request missing information on execution." << endl;
		cout << "                  i.e. silent-die mode." << endl;
	}

	if (printoptions[2])
	{
		//cout << endl;
		//cout << "      The following take presedense over those specified within a" << endl;
		//cout << "      config file:" << endl;
		cout << endl;
		cout << "      -ftp:[address]        e.g. -ftp:255.255.255.255" << endl;
		cout << "      -port:[#]             e.g. -port:22" << endl;
		cout << "      -username:[username]  e.g. -username:m1ckey" << endl;
		cout << "      -password:[password]  e.g. -password:adm1n" << endl;
		cout << "      -directory:[path]     e.g. -directory:/pub/" << endl;
		cout << "      -filename:[filename]  e.g. -filename:myip.txt" << endl;
		cout << "      -addressnumber:[#]    e.g. -addressnumber:0" << endl;
	}

	if (printoptions[1])
	{
		//cout << endl;
		//cout << "For quickest results, simply alter the ip2ftp.cfg file distributed with" << endl;
		//cout << "this application and execute 'ip2cfg ip2cfg.cfg'." << endl;
		cout << endl;
		cout << "Please read the readme.txt file distributed with this application or visit" << endl;
		cout << "http://www.m1ckey.uklinux.net/ip2ftp for detailed explanations of its use.";
	}

}

char* dropParam(char* param, int len)
{
	int l;
	char *temp = new char[strlen(param)-len];
	for (l = len; l <= strlen(param); l++)
	{
		temp[l-len] = param[l];
	}
	return temp;
}

bool allTrue(bool bset[], int num)
{
	int k;
	bool all = true;
	for (k = 0; k < num; k++)
	{
		if (bset[k] != true) {all = false;}
	}

	return all;
}