// ipops.cpp: implementation of the ipops class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ip2ftp.h"
#include "ipops.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

ipops::ipops()
{
	// required version of winsock (2.0)
	wVersionRequested = MAKEWORD( 2, 0 );
	// we have no addresses yet for this host
	numAddresses = 0;
}

ipops::~ipops()
{
	WSACleanup();
}

bool ipops::initWinsock()
{
	// check for winsock version 2.0 or above
	if (WSAStartup(wVersionRequested, &wsaData) != 0) {return false;}
	return true;
}

char* ipops::getHostName()
{
	// attempt to retrieve the host name of the computer
	if (gethostname(hostName,sizeof(hostName)) == SOCKET_ERROR) {return false;}
	return hostName;
}

int ipops::getnumAddresses()
{
	phe = gethostbyname(hostName);
	if (!phe) {return -1;}

	numAddresses = 0;
	int i = 0;

	while (phe->h_addr_list[i])
	{
		numAddresses ++;
		i ++;
	}

	return numAddresses;
}

char* ipops::getIPAddress_byAddressNum(int addressNum)
{
	phe = gethostbyname(hostName);

	// no such address
	if (addressNum >= numAddresses) {return "e";}

	memcpy(&addr, phe->h_addr_list[addressNum], sizeof(struct in_addr));

	return inet_ntoa(addr);
}
